//----------------------------------------------------------------------------
// 
//	file: latw_window.h
// 
//	function: lateral weight display window
//	author:   Yoonsuck Choe <yschoe@cs.utexas.edu>
//	creation: Fri Oct 23 06:04:50 CDT 1998
// 
//	$Revision: 1.2 $ $Date: 1999/02/09 07:42:25 $
//	$Log: latw_window.h,v $
//	Revision 1.2  1999/02/09 07:42:25  yschoe
//	instar-outstar is not explicitly selectable
//
//	Revision 1.1  1998/10/26 03:47:56  yschoe
//	Initial revision
//
//
//----------------------------------------------------------------------------
#ifndef __LATW_WINDOW_H
#define __LATW_WINDOW_H

#include "affw_window.h"

// selection between different displays : excitatory weights,
// inhibitory weights, and combined weights
enum LATW_TYPE {LATW_EXC, LATW_INH, LATW_COMB};

class latw_window : public affw_window {

private:

  LATW_TYPE selection;	
  REAL mult;		// controls brightness
  int  is_instar;

public:

  latw_window(char *name, netlayer *map, int width, int height, 
		LATW_TYPE sel = LATW_COMB, 
		REAL mult = (REAL)1.0, int is_instar=0);
  ~latw_window();

  void redraw();

};
#endif
