#include "real.h"
#include "sigmoid.h"
#include "blackboard.h"
#include "spike-code.h"

define MIN_REAL (1.0E-40)

	int	**aff_q[];	// afferent incoming queues 
	int 	**lat_exc_q;	// lateral excitatory incoming queues
	int	**lat_inh_q;	// lateral inhibitory incoming queues
	int	*inh_loop;	// inhibitory loop : implements reftactory p.
	REAL	loop_decay;	// decay rate for inh_loop
	REAL	lat_exc_decay;	// decay rate for lat_exc
	REAL	lat_inh_decay;	// decay rate for lat_inh

  // Leaky integrated queue look-up tables
  int   LUT_size;	// LUT size 
  REAL	aff_LUT[]; 	// afferent connection LUT
  REAL	lat_exc_LUT[]; 	// afferent connection LUT
  REAL	lat_inh_LUT[]; 	// afferent connection LUT
  REAL	loop_LUT[]; 	// afferent connection LUT

  // These are 2D matrices, for map layer [x][y].
  int		**spike;	// spike activity of this layer
