#include <iostream.h>
#include <nnview/simenv.h>
#include <nnview/spikelayer.h>
#include <nnview/parser.h>

int addition (int argc, char *argv[]) {

  if (argc!=2) return -1;
 
  int val = atoi(argv[1]) + atoi(argv[2]);
  cout << "addition() result = " << val << endl;
  return val;
}

int main (int argc, char *argv[]) {

  char cmd[100];
  int	i = 100;
  int   j = 200;
  int	*map;
  REAL  r = 0.1;

  // netlayer *net = new netlayer("map",10,10,2,10,0);
  spikelayer *net = new spikelayer("map",10,10,3,8,1,NULL,0,0,0,
                0.3,0.1,0.4,0.5);

  map = new int [10];

  for (int k=0; k<10; ++k) { map[k] = k; }

  simenv *testenv = new simenv("welcome",100) ;

  // add regular scalar variables
  testenv->add("i",&i);
  testenv->add("j",&j);
  testenv->add("r",&r);

  // add a vector variable
  testenv->add("map",map,10);

  // add an object. This must precede member function registration.
  testenv->add_obj("net",net,"test network layer");

  // regular C-like function test
  testenv->add_cmd("addition",addition,2,"adds arg1 and arg2"); 

  // netlayer member function test
  testenv->add_cmd("net->update_sig",
		"net",
		spikelayer::call_update_sig,
		2,"update_sig <float-sig low> <float-sig high>"); 
  testenv->add_cmd("net->addition",
		"net",
		spikelayer::addition,
		2,"addition <arg1> <arg2> -> result : int <arg1>+<arg2>"); 
  testenv->add_cmd("net->kill_lat_weights",
		"net",
		spikelayer::call_kill_lat_weights,
		1,"kill_lat_weights <float-thresh>"); 
  testenv->add_cmd("net->resize_lat_exc_rad",
		"net",
		spikelayer::call_resize_lat_exc_rad,
		1,"resize_lat_exc_rad <int-new radius>"); 

  int cnt = 0;
  while (!feof(stdin)) {

	cout << "simenvtest > ";
	fgets(cmd,100,stdin);
	testenv->parse(cmd);

	cout << " i = " << i << " j = " << j << " r = " << r << endl;
   	cout << "map : " ;
        for (int k=0; k<10; ++k) { cout << map[k] << " ";}
	cout << endl;

	cout << "net->cols = " << net->cols << endl;
	testenv->list_hook(SIM_HOOK_ALL);

	if (cnt++ == 5) {
		testenv->run_hooks_init();
		testenv->run_hooks_before(10);
		testenv->run_hooks_after(10);
	}
	testenv->help();
  }

  delete testenv;

}

