//----------------------------------------------------------------------------
//	calc_single_or_pref() 
//	  - calculate or pref : copied from netlayer.cc
//----------------------------------------------------------------------------
REAL calc_single_or_pref(

	REAL **ref_pattern, 
	REAL **actual_pattern,
	int x_size, int y_size, 
	REAL sigmax, REAL sigmay) {

  // for 0 to 180 degrees, place gaussian blob on the COG of that
  // neuron's afferent weight matrix, and calculate the maximally
  // responding one, and return it in 0.0(0deg)-1.0(180deg) scale.
  int samples = 18;
  int step    = samples/6;
  REAL max_or_resp[samples];

  int location;

  REAL mult = 180.0/(REAL)samples;
  REAL max_resp = -99999.9;
  int  max_idx  = 0;

  for (int i=0; i<samples; ++i) {
	max_or_resp[i] = 0.0;
  }

  for (int k=0; k<samples; k += step) { // for 0 - 180 degree rotation

    int diag = (int)(sqrt(x_size*x_size+y_size*y_size)*1.5);
    for (int p=0; p<MAX(x_size,y_size); ++p) { // for a complete sweep from left to right
      // generate gaussian
      for (int i=0; i<x_size; ++i)
          for (int j=0; j<y_size; ++j)
                ref_pattern[i][j] = 0.0;

      if (k<samples/2) {
                geninput::gaussian(ref_pattern, x_size, y_size,
                        (int)x_size-p,p, 
			(REAL)x_size*2.0, (REAL)5.0, (REAL)(k * mult));
      } else {
                geninput::gaussian(ref_pattern, x_size, y_size,
                        x_size-p, (int)y_size-p,
			(REAL)x_size*2.0, (REAL)5.0, (REAL)(k * mult));
      }

/*
      matw2->redraw();
      XFlush(display);
*/

      // calc dotproduct (as a vector)
      REAL dot = 0.0;
      for (int i=0; i<x_size; ++i)
          for (int j=0; j<y_size; ++j)
	      if (RADIUS(i,j,N/2,N/2)<N/2)	
              	dot += ref_pattern[i][j]*actual_pattern[i][j];
      //debug: cout << dot;

      if (dot>=max_or_resp[k]) {
          max_or_resp[k] = max_resp = dot;
	  max_idx  = k;
          //debug: cout << " " << k << " * "  << max_resp << endl;
	  match->clear_input();

/*
          if (k<samples/2) {
		match->add_input(
			(int)x_size-p,y_size,
			(REAL)(x_size*2.0), (REAL)1.0, (REAL)(k * mult));
          } else {
		match->add_input(
			x_size-p, (int)y_size-p,
			(REAL)(x_size*2.0), (REAL)1.0, (REAL)(k * mult));
          }
      	  matw3->redraw();
          XFlush(display);
*/
      } else {
          //debug: cout << endl;
      }
    }
    //debug: cout << "-------" << endl;

  }

  /*
  max_or_resp[0] = 10.0;
  max_or_resp[step] = 20.0;
  max_or_resp[step*2] = 10.0;
  */

  // Calculate vector sum
  REAL vector_sum = 0.0;
  REAL sum = 0.0;
  REAL cart_x = 0.0;
  REAL cart_y = 0.0;  
  REAL comp = 0.0;
  REAL selectivity = 0.0;
  int  count=0;
  for (int i=0; i<samples; i+=step) {
	cart_x += max_or_resp[i] * cos(2.0*i*10.0*3.141592/180.0);
	cart_y += max_or_resp[i] * sin(2.0*i*10.0*3.141592/180.0);
	count ++;
  }

  // cout << "count = " << count << endl;

  cart_x = cart_x;
  cart_y = cart_y;

  vector_sum = 180.0*atan2(cart_y,cart_x)/3.141592/2.0; 
  selectivity = sqrt(cart_y*cart_y+cart_x*cart_x);
  cout << "selectivity " << selectivity << endl;
  if (vector_sum < 0.0) vector_sum += 180.0;

  // cout << "vector_sum (" << cart_x << ","
  //	<< cart_y << ") " << "angle= " << vector_sum << endl;

/*
   match->clear_input();
  if (vector_sum<samples*10/2) {
	match->add_input(
		x_size/2,y_size/2,
		(REAL)(x_size*2.0), (REAL)1.0, (REAL)(vector_sum));
  } else {
	match->add_input(
		x_size/2,y_size/2,
		(REAL)(x_size*2.0), (REAL)1.0, (REAL)(vector_sum));
  }
  matw3->redraw();
  XFlush(display);
*/

  //debug: cout << "------------------" << endl;

  return (vector_sum/180.0); // 0.0 == 0 degree, 1.0 == 180 degrees

}
