;; hsv-rot
;; author: Yoonsuck Choe
;;

(define (script-fu-hsv-rot inStep)

	(let* ((step inStep)(img 0)(drawable 2)(n drawable)) 

		;; convert to RGB if image is INDEXED
		(if (= 1 (car (gimp-drawable-is-indexed drawable)))
			 (gimp-convert-rgb img))

		;; copy current layer, add the layer, and rotate HUE by step
		;; degrees
		(while (< n (+ (/ 360 step) 2)) 
			(gimp-layer-copy n TRUE) 
			;; new copied layer is now n+1
			(set! n (+ n 1)) 
			(gimp-image-add-layer img n -1) 
			;; Strangely, value shift 0.0 makes image darker
			(gimp-hue-saturation n ALL-HUES step 0 2.0)
		)

	)
)

(script-fu-register
	"script-fu-hsv-rot"
	"<Toolbox>/Xtns/Script-Fu/Misc/HSV Rotate Animation - Simple"
	"Create multiple layers with the Hue value shifted by inStep degrees."
       "Yoonsuck Choe"
       "copyright 2001, Yoonsuck Choe "
       "Mar 3, 2001"
       ""
       SF-VALUE "Step:"       "20"

)
